<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: install.def.php
 * @link       http://www.wowroster.net
 * @package    WoWepgpInstall
 * @subpackage Installer
*/
 
if ( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}
 
/**
 * Installer WoW EpGp
 *
 * @package    wowepgp
 * @subpackage Installer
 */
class wowepgpInstall
{
	var $active = true;
	var $icon = "epgp.png";
	var $version = '1.0.0';
	var $wrnet_id = 0;
	var $fullname = 'epgp';
	var $description = 'epgp_desc';
	var $credits = array(
	array(  "name"=>	"Kyndred",
			"info"=>	"Original Author"),
    array(  "name"=>    "Ulminia",
            "info"=>    "Contributor")

	);
 
 
	/**
	 * Install Function
	 *
	 * @return bool
	 */
	function install()
	{
		global $installer;
 
		// Master and menu entries
		$installer->add_config("12000,'startpage','epgp_conf','display','master'");
		$installer->add_config("12001,'epgp_config',NULL,'blockframe','menu'");
		$installer->add_config("12002,'decay_value','0','text{4|30','epgp_config'");
		$installer->add_config("12003,'base_value','0','text{4|30','epgp_config'");
		$installer->add_config("12004,'min_value','0','text{4|30','epgp_config'");
		$installer->add_config("12005,'extra_value','0','text{4|30','epgp_config'");
		$installer->add_config("12100,'epgp_upload','rostercp-addon-wowepgp-upload','makelink','menu'");
		$installer->add_menu_button('epgpbutton','guild','','epgp.png');
		$installer->create_table($installer->table('epgp'),"
                        `decay_value` int(11) NOT NULL DEFAULT 0,
						`base_value` int(11) NOT NULL DEFAULT 0,
						`min_value` int(11) NOT NULL DEFAULT 0,
						`extra_value` int(11) NOT NULL DEFAULT 0,
                        PRIMARY KEY (`decay_value`, `base_value`, `min_value`, `extra_value`)");
		
		return true;
	}
 
	/**
	 * Upgrade Function
	 *
	 * @param string $oldversion
	 * @return bool
	 */
	function upgrade($oldversion)
	{
		global $installer;
 
		if( version_compare('1.0.0', $oldversion,'>') == true )
		{
			// Upgrade versions lower than 1.0.0
		}
 
 
		return true;
	}

	/**
	 * Un-Install Function
	 *
	 * @return bool
	 */
	function uninstall()
	{
		global $installer;
 
		$installer->remove_all_config();
        $installer->drop_table($installer->table('epgp'));
		$installer->remove_all_menu_button();
		
		return true;
	}
}